"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var LightReactTooltip =
/*#__PURE__*/
function (_Component) {
  _inherits(LightReactTooltip, _Component);

  function LightReactTooltip(props) {
    var _this;

    _classCallCheck(this, LightReactTooltip);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(LightReactTooltip).call(this, props));
    _this.customStyles = {};

    if (_this.props.style) {
      _this.customStyles = _this.props.style;
    }

    ;
    return _this;
  }

  _createClass(LightReactTooltip, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var customePosition = "default";

      if (this.props.position) {
        customePosition = this.props.position;
      }

      var tooltipClass = "light-react-tooltip";

      if (this.props.tooltipClassName) {
        tooltipClass = this.props.tooltipClassName;

        if (!tooltipClass.includes("light-react-tooltip")) {
          console.error("light-react-tooltip :- if you setting a custom class it should begin with 'light-react-tooltip'");
          console.error("ex:- light-react-tooltip-1");
          console.error("ex:- light-react-tooltip-2");
          console.error("ex:- light-react-tooltip-username");
          return;
        }
      }

      document.addEventListener("mouseover", function (event) {
        var element = event.target;

        if (element.classList.contains(tooltipClass)) {
          showToolTip(element);
        }
      });
      document.addEventListener("mouseout", function (event) {
        var element = event.target;

        if (element.classList.contains(tooltipClass)) {
          hideToolTip();
        }
      });
      document.addEventListener("scroll", function (event) {
        hideToolTip();
      });

      function showToolTip(ele) {
        var tooltip = document.getElementById("".concat(tooltipClass, "-popup"));
        tooltip.style.visibility = "visible";

        if (ele.getAttribute("data-tip")) {
          tooltip.textContent = ele.getAttribute("data-tip");
        }

        setPositions(ele, tooltip);
      }

      function hideToolTip() {
        var tooltip = document.getElementById("".concat(tooltipClass, "-popup"));
        tooltip.style.visibility = "hidden";
      }

      function setPositions(ele, tooltip) {
        var coords = ele.getBoundingClientRect();

        if (customePosition == "default" || customePosition == "topLeft") {
          tooltip.style.top = coords.top - tooltip.offsetHeight + 'px';
          tooltip.style.left = coords.left + 'px';
        } else if (customePosition == "topRight") {
          tooltip.style.top = coords.top - tooltip.offsetHeight + 'px';
          tooltip.style.left = coords.left + ele.offsetWidth + 'px';
        } else if (customePosition == "bottomLeft") {
          tooltip.style.top = coords.top + ele.offsetHeight + 'px';
          tooltip.style.left = coords.left + 'px';
        } else if (customePosition == "bottomRight") {
          tooltip.style.top = coords.top + ele.offsetHeight + 'px';
          tooltip.style.left = coords.left + ele.offsetWidth + 'px';
        }
      }
    }
  }, {
    key: "render",
    value: function render() {
      var defaultStyle = {
        visibility: 'hidden',
        backgroundColor: 'black',
        color: '#fff',
        textAlign: 'center',
        borderRadius: '6px',
        padding: '5px 10px',
        margin: "0px 0px 0px 0px",
        zIndex: "1000",
        position: "fixed",
        fontFamily: "Arial, Helvetica, sans-serif",
        fontSize: "14px",
        fontWeight: "bold",
        fontStyle: "normal",
        fontStretch: "normal",
        lineHeight: "normal",
        letterSpacing: "normal",
        opacity: "0"
      };
      var tooltipClass = "light-react-tooltip";

      if (this.props.tooltipClassName) {
        tooltipClass = this.props.tooltipClassName;
      }

      return _react["default"].createElement("span", {
        id: "".concat(tooltipClass, "-popup"),
        style: Object.assign({}, defaultStyle, this.customStyles)
      }, "Add data-tip in your button !!!");
    }
  }]);

  return LightReactTooltip;
}(_react.Component);

exports["default"] = LightReactTooltip;
