import React, { Component } from 'react';

export default class LightReactTooltip extends Component {

    constructor(props){
        super(props);
        this.customStyles = {
        };
        if(this.props.style){
            this.customStyles = this.props.style;
        };
    }

    componentDidMount(){
        let customePosition = "default";
        if(this.props.position){
            customePosition = this.props.position;
        }
        let tooltipClass = "light-react-tooltip";
        if(this.props.tooltipClassName){
            tooltipClass = this.props.tooltipClassName;
            if(!tooltipClass.includes("light-react-tooltip")){
                console.error("light-react-tooltip :- if you setting a custom class it should begin with 'light-react-tooltip'");
                console.error("ex:- light-react-tooltip-1");
                console.error("ex:- light-react-tooltip-2");
                console.error("ex:- light-react-tooltip-username");
                return;
            }
        }
        document.addEventListener("mouseover", function(event){
            const element = event.target;
            if(element.classList.contains(tooltipClass)){
                showToolTip(element);
            }
        });
        document.addEventListener("mouseout", function(event){
            const element = event.target;
            if(element.classList.contains(tooltipClass)){
                hideToolTip()
            }
        });
        document.addEventListener("scroll", function(event){
            hideToolTip()
        });
        function showToolTip(ele){
            const tooltip = document.getElementById(`${tooltipClass}-popup`);
            tooltip.style.visibility = "visible";
            if(ele.getAttribute("data-tip")){
                tooltip.textContent = ele.getAttribute("data-tip");
            }
            setPositions(ele, tooltip);
        }
        function hideToolTip(){
            const tooltip = document.getElementById(`${tooltipClass}-popup`);
            tooltip.style.visibility = "hidden";
        }

        function setPositions(ele, tooltip){
            const coords = ele.getBoundingClientRect();
            if(customePosition == "default" || customePosition == "topLeft"){
                tooltip.style.top = (coords.top - tooltip.offsetHeight)+'px';
                tooltip.style.left = coords.left+'px';
            }
            else if(customePosition == "topRight"){
                tooltip.style.top = (coords.top - tooltip.offsetHeight)+'px';
                tooltip.style.left = (coords.left + ele.offsetWidth)+'px';
            }
            else if(customePosition == "bottomLeft"){
                tooltip.style.top = (coords.top + ele.offsetHeight)+'px';
                tooltip.style.left = (coords.left)+'px';
            }
            else if(customePosition == "bottomRight"){
                tooltip.style.top = (coords.top + ele.offsetHeight)+'px';
                tooltip.style.left = (coords.left + ele.offsetWidth)+'px';
            }
        }
    }

    render () {

        const defaultStyle = {
            visibility: 'hidden',
            backgroundColor: 'black',
            color: '#fff',
            textAlign: 'center',
            borderRadius: '6px',
            padding: '5px 10px',
            margin: "0px 0px 0px 0px",
            zIndex: "1000",
            position: "fixed",
            fontFamily: "Arial, Helvetica, sans-serif",
            fontSize: "14px",
            fontWeight: "bold",
            fontStyle: "normal",
            fontStretch: "normal",
            lineHeight: "normal",
            letterSpacing: "normal",
            opacity: "0"

        };

        let tooltipClass = "light-react-tooltip";
        if(this.props.tooltipClassName){
            tooltipClass = this.props.tooltipClassName;
        }

        return (
            <span id={`${tooltipClass}-popup`} style={Object.assign({},defaultStyle, this.customStyles)}>Add data-tip in your button !!!</span>
        )
    }

}
